org.optaplanner.core.impl.score

## Class DefaultScoreManager<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.score.DefaultScoreManager<Solution_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
  All Implemented Interfaces:
    ScoreManager<Solution_>

      public class DefaultScoreManager<Solution_>
      extends Object
      implements ScoreManager<Solution_>

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultScoreManager(ScoreDirectorFactory<Solution_> scoreDirectorFactory)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `explainScore(Solution_ solution)` Returns a diagnostic text that explains the solution through the `ConstraintMatch` API to identify which constraints or planning entities cause that score quality.
    `ScoreDirectorFactory<Solution_>` | `getScoreDirectorFactory()`
    `Score` | `updateScore(Solution_ solution)` Calculates the `Score` of a `PlanningSolution` and updates its `PlanningScore` member.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.ScoreManager

      `create`

- - ### Constructor Detail

    - #### DefaultScoreManager

          public DefaultScoreManager(ScoreDirectorFactory<Solution_> scoreDirectorFactory)

  - ### Method Detail

    - #### getScoreDirectorFactory

          public ScoreDirectorFactory<Solution_> getScoreDirectorFactory()

    - #### updateScore

          public Score updateScore(Solution_ solution)

      Description copied from interface: `ScoreManager`
      Calculates the `Score` of a `PlanningSolution` and updates its `PlanningScore` member.
      Specified by:
        `updateScore` in interface `ScoreManager<Solution_>`
      Parameters:
        `solution` - never null

    - #### explainScore

          public String explainScore(Solution_ solution)

      Description copied from interface: `ScoreManager`
      Returns a diagnostic text that explains the solution through the `ConstraintMatch` API to identify which constraints or planning entities cause that score quality. In case of an `infeasible` solution, this can help diagnose the cause of that.

      Do not parse this string. Instead, to provide this information in a UI or a service, use `SolverFactory.getScoreDirectorFactory()` to retrieve `ScoreDirector.getConstraintMatchTotalMap()` and `ScoreDirector.getIndictmentMap()` and convert those into a domain specific API.

      This method is thread-safe.

      Specified by:
        `explainScore` in interface `ScoreManager<Solution_>`
      Returns:
        null if `ScoreManager.updateScore(Object)` returns null with the same solution
      See Also:
        `ScoreDirector.explainScore()`

Copyright © 2006–2021 JBoss by Red Hat. All rights reserved.